class GGJFayrie extends Actor placeable;
var PointLightComponent Light;
var AnimNodeBlend isCollectedNode;
var SkeletalMeshComponent FayrieM;

simulated Function PostBeginPlay()
{
    Light=new(self)class'PointLightComponent';
    Light.setEnabled(false);
    Light.SetLightProperties(1.0f);
    Light.UpdateColorAndBrightness();
    self.AttachComponent(light);
}

simulated singular event Touch( Actor Other, PrimitiveComponent OtherComp, vector HitLocation, vector HitNormal )
{
    if (Pawn(Other) != None && Pawn(Other).Controller.bIsPlayer) //We wouldn't want potential NPCs to get coins.
    {
        if (GlobalGameJamInfo(WorldInfo.Game) != None)
        {
            Light.SetEnabled(true);
            isCollectedNode = AnimNodeBlend(FayrieM.FindAnimNode('isCollectedNode'));
            isCollectedNode.SetBlendTarget(1, 0.2);  
            GlobalGameJamInfo(WorldInfo.Game).AddScore(1);
        }
    }
}

defaultproperties
{
    bCollideActors=true    
    bBlockActors=false
    
    Begin Object class=SkeletalMeshComponent name=FayrieMdl
        SkeletalMesh=SkeletalMesh'GGJ-TimChar.Meshes.Fayrie'
        AnimSets(0)=AnimSet'GGJ-TimChar.Meshes.FayrieAnimset'
        AnimtreeTemplate=AnimTree'GGJ-TimChar.AnimTree.FayrieAnimTree'
    End Object
    
    Begin Object Class=PointLightComponent Name=PointLight
        Brightness=1.0f
        CastDynamicShadows=true
        CastShadows=true
        bCastCompositeShadow=true
        LightingChannels=(BSP=TRUE,Static=TRUE,Dynamic=TRUE,CompositeDynamic=TRUE,bInitialized=TRUE)
        Translation=(Z=50)
        End Object

    
    Light = PointLight;


    Begin Object Class=CylinderComponent Name=CollisionCylinder
        CollisionRadius = 32.0
        CollisionHeight = 64.0
        BlockActors=false
        CollideActors=true
    End Object
        
    FayrieM=FayrieMdl
    CollisionComponent=CollisionCylinder
    Components.Add(CollisionCylinder)
    Components.Add(FayrieMdl)
}